osl::NumBitmapEffect Class Reference

現在の定義 (2005/3/4以降) More...

`#include <numBitmapEffect.h>`

Inheritance diagram for osl::NumBitmapEffect:

## Public Types

enum | Op { Add , Sub }

## Public Member Functions

| NumBitmapEffect ()
int | countEffect (Player pl) const
template<Op OP>
NumBitmapEffect & | opEqual (NumBitmapEffect const &rhs)
const mask_t | selectLong () const
template<Ptype PTYPE>
const mask_t | selectLong () const
bool | hasLong () const
template<Ptype PTYPE>
bool | hasLong () const
template<Ptype PTYPE>
bool | hasAny () const
Public Member Functions inherited from osl::PieceMask
| PieceMask ()
| PieceMask (const PieceMaskBase &base)
void | setMask (int index, mask_t val)
void | xorMask (int index, mask_t val)
void | orMask (int index, mask_t val)
bool | test (int num) const
void | set (int num)
void | flip (int num)
void | reset (int num)
bool | any () const
const mask_t | getMask (int num) const
template<Ptype PTYPE>
const mask_t | getMask () const
| unpromote(PTYPE) の駒のbit を*含む*mask_tを取り出す
template<Ptype PTYPE>
const mask_t | selectBit () const
| unpromote(PTYPE) の駒のbit だけ取り出す
template<Ptype PTYPE>
void | clearBit ()
| unpromote(PTYPE) の駒のbit を消す
template<Ptype PTYPE>
void | setBit ()
| unpromote(PTYPE) の駒のbit を立てる
Public Member Functions inherited from osl::container::PieceMask64
| PieceMask64 ()
| PieceMask64 (misc::Mask64 const &m)
const misc::Mask64 & | getMask (int) const
void | resetAll ()
void | setAll ()
PieceMask64 & | operator^= (const PieceMask64 &o)
PieceMask64 & | operator&= (const PieceMask64 &o)
PieceMask64 & | operator|= (const PieceMask64 &o)
PieceMask64 & | operator-= (const PieceMask64 &o)
PieceMask64 & | operator+= (const PieceMask64 &o)
bool | none () const
bool | hasMultipleBit () const
int | countBit2 () const
| bit の数を2まで数える
int | countBit () const
int | takeOneBit ()

## Static Public Member Functions

template<Player P>
static NumBitmapEffect | playerEffect ()
static NumBitmapEffect | playerEffect (Player pl)
template<Player P>
static mask_t | playerEffectMask ()
static mask_t | playerEffectMask (Player pl)
template<Player P>
static NumBitmapEffect | makeEffect (int num)
static const mask_t | longEffectMask ()
static const mask_t | makeLongMask (int num)
template<Player P>
static NumBitmapEffect | makeLongEffect (int num)
static NumBitmapEffect | makeLongEffect (Player pl, int num)
Static Public Member Functions inherited from osl::PieceMask
static const mask_t | numToMask (int num)
Static Public Member Functions inherited from osl::container::PieceMask64
static int | numToIndex (int)
static int | numToOffset (int num)

## Additional Inherited Members

Protected Member Functions inherited from osl::container::PieceMask64
misc::Mask64 & | mutableMask (int)
Protected Attributes inherited from osl::container::PieceMask64
Mask64 | mask

## Detailed Description

現在の定義 (2005/3/4以降)

- 0-39 : 0-39の利き
- 40-47 : 32-39の長い利き
- 48-53 : 黒の利きの数(sentinelを合わせて6bit)
- 54-59 : 白の利きの数(sentinelを合わせて6bit)

以前の定義 (2004/4/13以降)

- 0-39 : 0-39の利き
- 40-47 : 32-39の長い利き

以前の定義

- 0-31 : 0-31の直接効き
- 32-39 : 32-39の短い効き(obsolete および32-39の短い間接効き)
- 40-47 : 32-39の長い効き(obsoleteおよび32-39の長い間接効き)

Definition at line 28 of file numBitmapEffect.h.

## Member Enumeration Documentation

## Op

enum osl::effect::NumBitmapEffect::Op

Enumerator
Add |
Sub |

Definition at line 95 of file numBitmapEffect.h.

## Constructor & Destructor Documentation

## NumBitmapEffect()

osl::effect::NumBitmapEffect::NumBitmapEffect | ( |  | ) |

inline

Definition at line 31 of file numBitmapEffect.h.

## Member Function Documentation

## countEffect()

int osl::effect::NumBitmapEffect::countEffect | ( | Player | pl | ) | const

inline

Definition at line 81 of file numBitmapEffect.h.

## hasAny()

template<Ptype PTYPE>

bool osl::effect::NumBitmapEffect::hasAny | ( |  | ) | const

inline

Definition at line 155 of file numBitmapEffect.h.

## hasLong() [1/2]

template<Ptype PTYPE>

bool osl::effect::NumBitmapEffect::hasLong | ( |  | ) | const

inline

Definition at line 151 of file numBitmapEffect.h.

## hasLong() [2/2]

bool osl::effect::NumBitmapEffect::hasLong | ( |  | ) | const

inline

Definition at line 142 of file numBitmapEffect.h.

## longEffectMask()

const mask_t osl::effect::NumBitmapEffect::longEffectMask | ( |  | ) |

inline static

Definition at line 107 of file numBitmapEffect.h.

Referenced by osl::effect::NumSimpleEffectTable::doBlockAt(), and osl::NumEffectState::hasEffectInDirection().

## makeEffect()

template<Player P>

NumBitmapEffect osl::effect::NumBitmapEffect::makeEffect | ( | int | num | ) |

inline static

Definition at line 90 of file numBitmapEffect.h.

Referenced by osl::effect::NumSimpleEffectTable::doEffectShort().

## makeLongEffect() [1/2]

template<Player P>

NumBitmapEffect osl::effect::NumBitmapEffect::makeLongEffect | ( | int | num | ) |

inline static

Definition at line 124 of file numBitmapEffect.h.

Referenced by osl::effect::NumSimpleEffectTable::doBlockAt(), and osl::effect::NumSimpleEffectTable::doEffectLong().

## makeLongEffect() [2/2]

NumBitmapEffect osl::effect::NumBitmapEffect::makeLongEffect | ( | Player | pl,
|  | int | num )

inline static

Definition at line 130 of file numBitmapEffect.h.

## makeLongMask()

const mask_t osl::effect::NumBitmapEffect::makeLongMask | ( | int | num | ) |

inline static

Definition at line 119 of file numBitmapEffect.h.

## opEqual()

template<Op OP>

NumBitmapEffect & osl::effect::NumBitmapEffect::opEqual | ( | NumBitmapEffect const & | rhs | ) |

inline

Definition at line 99 of file numBitmapEffect.h.

## playerEffect() [1/2]

template<Player P>

NumBitmapEffect osl::effect::NumBitmapEffect::playerEffect | ( |  | ) |

inline static

Definition at line 35 of file numBitmapEffect.h.

Referenced by osl::NumEffectState::hasMultipleEffectAt().

## playerEffect() [2/2]

NumBitmapEffect osl::effect::NumBitmapEffect::playerEffect | ( | Player | pl | ) |

inline static

Definition at line 41 of file numBitmapEffect.h.

## playerEffectMask() [1/2]

template<Player P>

mask_t osl::effect::NumBitmapEffect::playerEffectMask | ( |  | ) |

inline static

Definition at line 53 of file numBitmapEffect.h.

Referenced by osl::effect::NumSimpleEffectTable::doBlockAt(), osl::effect::NumSimpleEffectTable::doEffectLong(), osl::effect::NumSimpleEffectTable::doEffectShort(), osl::NumEffectState::hasEffectAt(), osl::NumEffectState::hasEffectAt(), and osl::NumEffectState::hasMultipleEffectAt().

## playerEffectMask() [2/2]

mask_t osl::effect::NumBitmapEffect::playerEffectMask | ( | Player | pl | ) |

inline static

Definition at line 65 of file numBitmapEffect.h.

## selectLong() [1/2]

template<Ptype PTYPE>

const mask_t osl::effect::NumBitmapEffect::selectLong | ( |  | ) | const

inline

Definition at line 146 of file numBitmapEffect.h.

## selectLong() [2/2]

const mask_t osl::effect::NumBitmapEffect::selectLong | ( |  | ) | const

inline

Definition at line 138 of file numBitmapEffect.h.

The documentation for this class was generated from the following file:

- numBitmapEffect.h